/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
"use strict";function stripComments(e){return e.replace(/("(?:[^\\\"]*(?:\\.)?)*")|('(?:[^\\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g,function(e,r,t,n,a){if(n)return"";if(a){let e=a.length;return e>2&&"\n"===a[e-1]?"\r"===a[e-2]?"\r\n":"\n":""}return e})}function getCommit(){if(_commit)return _commit;if(null!==_commit){try{let e=require(path.join(__dirname,"../product.json"));_commit=e.commit?e.commit:null}catch(e){_commit=null}return _commit||void 0}}function mkdirp(e){return mkdir(e).then(null,r=>{if(r&&"ENOENT"===r.code){let r=path.dirname(e);if(r!==e)return mkdirp(r).then(()=>mkdir(e))}throw r})}function mkdir(e){return new Promise((r,t)=>{fs.mkdir(e,n=>{n&&"EEXIST"!==n.code?t(n):r(e)})})}function exists(e){return new Promise(r=>{fs.exists(e,e=>{r(e)})})}function readFile(e){return new Promise((r,t)=>{fs.readFile(e,"utf8",(e,n)=>{e?t(e):r(n)})})}function writeFile(e,r){return new Promise((t,n)=>{fs.writeFile(e,r,"utf8",e=>{e?n(e):t(void 0)})})}function touch(e){
return new Promise((r,t)=>{let n=new Date;fs.utimes(e,n,n,e=>{e?t(e):r(void 0)})})}function getUserDefinedLocale(){let e=args.locale;if(e)return Promise.resolve(e.toLowerCase());let r=app.getPath("userData"),t=path.join(r,"User","locale.json");return exists(t).then(e=>e?readFile(t).then(e=>{e=stripComments(e);try{let r=JSON.parse(e).locale;return r&&"string"==typeof r?r.toLowerCase():void 0}catch(e){return}}):void 0)}function getLanguagePackConfigurations(){let e=app.getPath("userData"),r=path.join(e,"languagepacks.json");try{return require(r)}catch(e){}}function resolveLanguagePackLocale(e,r){try{for(;r;){if(e[r])return r;{let e=r.lastIndexOf("-");if(!(e>0))return;r=r.substring(0,e)}}}catch(e){console.error("Resolving language pack configuration failed.",e)}}function getNLSConfiguration(e){if("pseudo"===e)return Promise.resolve({locale:e,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:e,availableLanguages:{}});let r=app.getPath("userData")
;if(e&&("en"==e||e.startsWith("en-")))return Promise.resolve({locale:e,availableLanguages:{}});let t=e,n=!0;if(e&&(n=["de","es","fr","it","ja","ko","ru","tr","zh-cn","zh-tw"].some(r=>e===r||e.startsWith(r+"-"))),n)return Promise.resolve(function(e){for(;e;){let r=path.join(__dirname,"vs","code","electron-main","main.nls.")+e+".js";if(fs.existsSync(r))return{locale:t,availableLanguages:{"*":e}};{let r=e.lastIndexOf("-");e=r>0?e.substring(0,r):void 0}}}(e));{perf.mark("nlsGeneration:start");let t=function(){return perf.mark("nlsGeneration:end"),Promise.resolve({locale:e,availableLanguages:{}})};try{let n=getCommit();if(!n)return t();let a=getLanguagePackConfigurations();if(!a)return t();let o=e;if(!(e=resolveLanguagePackLocale(a,e)))return t();let i,s=a[e];return s&&"string"==typeof s.hash&&s.translations&&"string"==typeof(i=s.translations.vscode)?exists(i).then(a=>{if(!a)return t();let l=s.hash+"."+e,u=path.join(r,"clp",l),c=path.join(u,n),p=path.join(u,"tcf.json"),f={locale:o,availableLanguages:{"*":e},
_languagePackId:l,_translationsConfigFile:p,_cacheRoot:u,_resolvedLanguagePackCoreLocation:c};return exists(c).then(e=>e?(touch(c).catch(()=>{}),perf.mark("nlsGeneration:end"),f):mkdirp(c).then(()=>Promise.all([readFile(path.join(__dirname,"nls.metadata.json")),readFile(i)])).then(e=>{let r=JSON.parse(e[0]),t=JSON.parse(e[1]).contents,n=Object.keys(r.bundles),a=[];for(let e of n){let n=r.bundles[e],o=Object.create(null);for(let e of n){let n,a=r.keys[e],i=r.messages[e],s=t[e];if(s){n=[];for(let e=0;e<a.length;e++){let r=a[e],t=s["string"==typeof r?r:r.key];void 0===t&&(t=i[e]),n.push(t)}}else n=i;o[e]=n}a.push(writeFile(path.join(c,e.replace(/\//g,"!")+".nls.json"),JSON.stringify(o)))}return a.push(writeFile(p,JSON.stringify(s.translations))),Promise.all(a)}).then(()=>(perf.mark("nlsGeneration:end"),f)).catch(e=>(console.error("Generating translation files failed.",e),t())))}):t()}catch(e){return console.error("Generating translation files failed.",e),t()}}}function getNodeCachedDataDir(){
if(process.argv.indexOf("--no-cached-data")>0)return Promise.resolve(void 0);if(process.env.VSCODE_DEV)return Promise.resolve(void 0);let e=getCommit();if(!e)return Promise.resolve(void 0);return mkdirp(path.join(app.getPath("userData"),"CachedData",e)).then(void 0,function(){})}let perf=require("./vs/base/common/performance");perf.mark("main:started"),global.perfStartTime=Date.now(),function(){const e=require("path"),r=require("module"),t=e.join(__dirname,"../node_modules"),n=t+".asar",a=r._resolveLookupPaths;r._resolveLookupPaths=function(e,r){const o=a(e,r),i=o[1];for(let e=0,r=i.length;e<r;e++)if(i[e]===t){i.splice(e,0,n);break}return o}}();let _commit,app=require("electron").app,fs=require("fs"),path=require("path"),minimist=require("minimist"),paths=require("./paths"),args=minimist(process.argv,{string:["user-data-dir","locale"]}),userData=path.resolve(args["user-data-dir"]||paths.getDefaultUserDataPath(process.platform));app.setPath("userData",userData);try{
"win32"===process.platform?(process.env.VSCODE_CWD=process.cwd(),process.chdir(path.dirname(app.getPath("exe")))):process.env.VSCODE_CWD&&process.chdir(process.env.VSCODE_CWD)}catch(e){console.error(e)}global.macOpenFiles=[],app.on("open-file",function(e,r){global.macOpenFiles.push(r)});let openUrls=[],onOpenUrl=function(e,r){e.preventDefault(),openUrls.push(r)};app.on("will-finish-launching",function(){app.on("open-url",onOpenUrl)}),global.getOpenUrls=function(){return app.removeListener("open-url",onOpenUrl),openUrls};let nodeCachedDataDir=getNodeCachedDataDir().then(function(e){return e&&(process.env["VSCODE_NODE_CACHED_DATA_DIR_"+process.pid]=e,app.commandLine.appendSwitch("--js-flags","--nolazy")),e}),nlsConfiguration=void 0,userDefinedLocale=getUserDefinedLocale();userDefinedLocale.then(e=>{e&&!nlsConfiguration&&(nlsConfiguration=getNLSConfiguration(e))}),app.once("ready",function(){perf.mark("main:appReady"),Promise.all([nodeCachedDataDir,userDefinedLocale]).then(e=>{let r=e[1]
;r&&!nlsConfiguration&&(nlsConfiguration=getNLSConfiguration(r)),nlsConfiguration||(nlsConfiguration=Promise.resolve(void 0)),nlsConfiguration.then(e=>{let r=e=>{process.env.VSCODE_NLS_CONFIG=JSON.stringify(e),require("./bootstrap-amd").bootstrap("vs/code/electron-main/main")};if(e)r(e);else{let e=app.getLocale();e?getNLSConfiguration(e=e.toLowerCase()).then(t=>{t||(t={locale:e,availableLanguages:{}}),r(t)}):r({locale:"en",availableLanguages:{}})}})},console.error)});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c63189deaa8e620f650cc28792b8f5f3363f2c5b/core/main.js.map
